unit inform;

interface

procedure fastwrite (s : string); { direkte Screenausgabe via DOS }
procedure newline; { CR/LF via DOS auf Bildschirm }
procedure stopp; { Auf Enter Tastendruck warten }
procedure some_Information; { Informationen zu TRDES }


implementation

procedure fastwrite (s : string); assembler;
{ direkte Screenausgabe via DOS }
asm
 les di,s;
 xor bx,bx;
@start:
 inc bx;
 cmp bl,[es:di]; ja @ende;
 mov al,[es:di][bx];
 push bx; int $29; pop bx;
 jmp @start;
@ende:
end;

procedure newline; assembler; { CR/LF via DOS auf Bildschirm }
asm
 mov al,$0d; int $29;
 mov al,$0a; int $29;
end;

procedure stopp; { Auf Enter Tastendruck warten }
begin
 writeln;
 fastwrite('<ENTER> drcken'); { Auf jeden Fall zum Bildschirm schicken }
 newline;                      { ebenfalls }
 readln;
end;

procedure some_Information;
begin
 writeln;
 writeln('HINWEISE UND BERMERKUNGEN:');
 writeln;
 writeln('DES steht fr Data Encryption Standard. Er wurde 1977 vom National Bureau');
 writeln('of Standards (NBS) in den USA zur Verwendung fr "unclassified computer');
 writeln('data" genormt. Ich habe mich in diesem Programm weitgehend nach diesem');
 writeln('Standard gerichtet, wobei ich vorsichtshalber auf folgendes hinweise:');
 writeln;
 writeln('1. Die Sicherheit des Verfahrens kann nicht garantiert werden.');
 writeln('   Mit hohem technischen Aufwand ist das Vefahren fr Experten sicherlich');
 writeln('   zu knacken. Die Schlssellnge ist mit effektiven 56 Bits dem massiven');
 writeln('   Einsatz schneller Hardware mglicherweise nicht gewachsen.');
 writeln('   Da durch die Standardisierung jedem das interne Design des Verfahrens');
 writeln('   offenliegt, knnten Experten vielleicht ein "Entschlsselungsprogramm"');
 writeln('   entwickeln, welches die verschlsselten Daten auch ohne Kenntnis des');
 writeln('   Schlssels entschlsseln kann. Doch diese Gefahr ist eigentlich bei');
 writeln('   jedem Verfahren gegeben.');
 stopp;
 writeln('2. Es kann nicht garantiert werden, da TRDES korrekt nach dem DES-Standard');
 writeln('  arbeitet.');
 writeln('   Mglicherweise haben sich Programmier-, bertragungsfehler oder andere Bugs');
 writeln('   eingeschlichen. Das Programm wurde nicht durch irgendwelche formalen Kor-');
 writeln('   rektheitsbeweise auf seine Korrektheit verifiziert.');
 writeln('   Das Programm wurde auch nicht primr fr den konkreten oder gar professio-');
 writeln('   nellen Einsatz entwickelt (hierfr gibt es spezielle Hardware, die wesent-');
 writeln('   lich schneller ist), sondern um das Design des DES-Vefahrens kennenzulernen');
 writeln('   und zu untersuchen.');
 stopp;
 writeln('Nun zu den zwei internen Modi des Programms:');
 writeln('Auch sie sind genormt. Das ECB-Verfahren (Electronic Code Book) arbeitet');
 writeln('streng monoalphabetisch, d.h. in diesem Fall: Gleiche 8-Byte-Blcke der Origi-');
 writeln('naldaten werden auch in gleiche 8-Byte-Blcke verschlsselt.');
 writeln('Es besteht daher die Gefahr, da charakteristische Blockwiederholungen in');
 writeln('den verschlsselten Daten Rckschlsse auf die Daten selbst liefern. Dies');
 writeln('wiederum vereinfacht die Entschlsselung enorm.');
 writeln('Das CBC-Verfahren ist in dieser Hinsicht sicherer, weil auch die Blcke unter-');
 writeln('einander zur Verschlsselung herangezogen werden. Nachteil dieses Verfahrens');
 writeln('ist die Anflligkeit fr bertragungsfehler der Daten. Ein falsches Bit in den');
 writeln('verschlsselten Daten pflanzt sich bei der Entschlsselung immer weiter fort,');
 writeln('so da auch bei Kenntnis des richtigen Schlssels eine Entschlsselung vllig');
 writeln('vernderte Daten liefert (ab der Stelle des fehlerhaften Bits). Das ECB-Verfah-');
 writeln('ren wrde hingegen nur den fehlerhaften Block falsch entschlsseln.');
 stopp;
 writeln('Zur Lnge und Beschaffenheit der Schlssel');
 writeln('Jeder Buchstabe wird in 4 Bits umgewandelt. Das Verfahren bentigt 64 Bits pro');
 writeln('Schlssel, d.h. 16 signifikante Buchstaben. Bei krzeren Schlsseln werden die');
 writeln('verbleibenden Bits mit Nullen aufgefllt; lngere Schlssel werden ab dem 16.');
 writeln('Buchstaben abgeschnitten, bringen also keine weitere Sicherheit.');
 writeln('Fr den ernsthaften Gebrauch wren also 16 Buchstaben erforderlich.');
 writeln('Auerdem sollten dann auch keine naheliegenden Schlssel verwendet werden.');
 writeln('Der erste Angriff auf die verschlsselten Daten erfolgt meist durch Raten');
 writeln('des Schlssels mit anschlieender berprfung der damit "entschlsselten"');
 writeln('Daten. Solche Angriffe knnen automatisiert werden, indem man Wrterbcher oder');
 writeln('Dateien mit vermuteten Schlsselwrtern durchtestet.');
 writeln('Die Sicherheit des DES-Vefahrens liegt ja gerade darin, da 2 hoch 56 verschie-');
 writeln('dene mgliche Schlsselwrter existieren und nicht nur die wenigen tausend');
 writeln('sinnvollen Buchstabenkombinationen, die die Wrter einer natrlichen Sprache');
 writeln('bilden.');
 writeln;
 writeln('OK. - Das wrs.');
 stopp;
end;


end.